<app-spinner *ngIf="!isPageLoaded"></app-spinner>
<mat-table #table [dataSource]="dataSource" matSort [matSortDisableClear]="true" class="app-table-grid">

  <!--- Note that these columns can be defined in any order.
        The actual rendered columns are set as a property on the row definition" -->

  <!-- Status Column -->
  <ng-container matColumnDef="status">
    <mat-header-cell *matHeaderCellDef mat-sort-header > Status </mat-header-cell>
    <mat-cell *matCellDef="let element" [ngSwitch]="element.status">
      <button mat-mini-fab *ngSwitchCase="'urgent'" class="status-button-urgent"></button>
      <button mat-mini-fab *ngSwitchCase="'important'" class="status-button-important"></button>
      <button mat-mini-fab *ngSwitchCase="'normal'" class="status-button-normal"></button>
    </mat-cell>
  </ng-container>

  <!-- Due Date Column -->
  <ng-container matColumnDef="due_date">
    <mat-header-cell *matHeaderCellDef mat-sort-header> Due Date </mat-header-cell>
    <mat-cell *matCellDef="let element"> {{element.due_date}} </mat-cell>
  </ng-container>

  <!-- Description Column -->
  <ng-container matColumnDef="description">
    <mat-header-cell *matHeaderCellDef mat-sort-header> Description </mat-header-cell>
    <mat-cell *matCellDef="let element"> {{element.description}} </mat-cell>
  </ng-container>

  <!-- Status Date Column -->
  <ng-container matColumnDef="status_date">
    <mat-header-cell *matHeaderCellDef mat-sort-header> Status Date </mat-header-cell>
    <mat-cell *matCellDef="let element"> {{element.status_date}} </mat-cell>
  </ng-container>

  <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
  <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
</mat-table>